import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



public class PictureCanvas extends ScaleCanvas implements MouseListener {
    AffineTransform[] A=new AffineTransform[2];
    Penrose[] P=new Penrose[200000];
    int count;
    ControlCanvas C;
    ListenSquare CONTROL;
    DocumentCanvas D;

     public PictureCanvas() {
	 addMouseListener(this);
	 C=new ControlCanvas();
	 setScales(400,400);
	 initialize();
	 subdivide();
	 D=new DocumentCanvas();
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawShapes(g);
      drawFrame(g);
      C.render(g);
      D.render(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(C.C2[3]);
	g.fillRect(0,0,getWidth(),getHeight());
    }

    public void drawFrame(Graphics2D g) {
	g.setColor(new Color(0,0,100));
	g.fillRect(0,0,getWidth(),75);
	g.setColor(new Color(50,100,255));
	g.setStroke(new BasicStroke(5));
	g.drawLine(0,75,950,75);	 
                  g.setStroke(new BasicStroke(1));
    }

    public void initialize() {

	if(C.SEED.val==0) {
	 P[0]=new Penrose();
	 P[0].z=new Complex(0,0);
	 P[0].w=new Complex(1,0);
	 P[0].shape=0;	
                   count=1;
	}

	if(C.SEED.val==1) {
	 P[0]=new Penrose();
	 P[0].z=new Complex(0,0);
	 P[0].w=new Complex(1,0);
	 P[0].shape=1;
	 count=1;
	}

	if(C.SEED.val==2) {
	    double th=Math.PI*2/5.0;
	    for(int i=0;i<5;++i) {
	      P[i]=new Penrose();
	      P[i].z=new Complex(0,0);
	      P[i].w=new Complex(Math.cos(th*i),Math.sin(th*i));
	      P[i].shape=0;	 
	     count=5;
	    }
	}

	if(C.SEED.val==3) {
	    double th=Math.PI*2/5.0;
	    for(int i=0;i<5;++i) {
	      P[i]=new Penrose();
	      P[i].z=new Complex(0,0);
	      P[i].w=new Complex(Math.cos(th*i),Math.sin(th*i));
	      P[i].shape=1;	 
	     count=5;
	    }
	}
    }

    public void subdivide() {
      for(int r=0;r<C.REFINE.val;++r) {
	Penrose[] temp=new Penrose[count];
	for(int i=0;i<count;++i) temp[i]=new Penrose(P[i]);
	Penrose[] temp2=Subdivide.subdivide(temp,C.MODE.val);	
	for(int i=0;i<temp2.length;++i) P[i]=new Penrose(temp2[i]);
	count=temp2.length;
      }
    }

    public AffineTransform[] getScale1() {
	AffineTransform[] AFF=new AffineTransform[2];  
	double s=Math.min(getWidth(),getHeight());
	s=s/2-200;
	s=s*Math.pow(1.3,C.SCALE.val);
	AFF[0]=AffineTransform.getScaleInstance(s,s);
	AFF[1]=AffineTransform.getTranslateInstance(getWidth()/2,getHeight()/2);
	return(AFF);

    }


    public AffineTransform[] getScale2() {
	Penrose X=new Penrose();
	 X=new Penrose();
	 X.z=new Complex(0,0);
	 X.w=new Complex(1,0);
	 X.shape=C.SEED.val;	
	GeneralPath gp=X.toPath();
	return(preFit(gp,270,110,getWidth()-450,getHeight()-440));  
    }

    public void drawShapes(Graphics2D g) { 
                  AffineTransform[] AFF=getScale1();
	if(C.SEED.val<2) AFF=getScale2();
	for(int i=0;i<count;++i) {  
	    g.setColor(C.C2[0]);
	    if(P[i].shape==1) g.setColor(C.C2[1]);
	    GeneralPath gp=P[i].toPath();
	    gp.transform(AFF[0]);
	    gp.transform(AFF[1]);
	    g.fill(gp);
	    g.setColor(C.C2[2]);
	    g.draw(gp);
	}
    }



    public void mousePressed(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {    
         MouseData J=MouseData.process(e);
          C.process(e);
          D.process(J.X);
           initialize();
           subdivide();
          repaint();
    }

     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   

}
